## vlock 1.0

=== Makefile ===
# vlock makefile

CC = gcc
# remove the -DUSE_PAM, -ldl, and -lpam if you aren't using PAM
CFLAGS = -O2 -DUSE_PAM
LDFLAGS = -ldl -lpam

OBJS = vlock.o signals.o help.o terminal.o input.o

vlock: $(OBJS)

vlock.man: vlock.1
	groff -man -Tascii vlock.1 > vlock.man

vlock.o: vlock.h version.h
signals.o: vlock.h
help.o: vlock.h
terminal.o: vlock.h
input.o: vlock.h

clean:
	rm -f $(OBJS) vlock core core.vlock

## vlock 1.2

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 CC = gcc
 # remove the -DUSE_PAM, -ldl, and -lpam if you aren't using PAM
 CFLAGS = -O2 -DUSE_PAM
-LDFLAGS = -ldl -lpam
+LDFLAGS = -ldl -lpam -lpam_misc
 
 OBJS = vlock.o signals.o help.o terminal.o input.o

## vlock 1.3

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,8 @@
 
 CC = gcc
 # remove the -DUSE_PAM, -ldl, and -lpam if you aren't using PAM
-CFLAGS = -O2 -DUSE_PAM
+RPM_OPT_FLAGS=-O2
+CFLAGS = $(RPM_OPT_FLAGS) -DUSE_PAM
 LDFLAGS = -ldl -lpam -lpam_misc
 
 OBJS = vlock.o signals.o help.o terminal.o input.o

## vlock 2.1

=== Makefile ===
# vlock makefile

include config.mk

override CFLAGS += -Isrc -DPREFIX="\"$(PREFIX)\""

VPATH = src

VLOCK_VERSION = 2.1

PROGRAMS = \
					vlock \
					vlock-current \
					vlock-new \
					vlock-all \
					vlock-nosysrq

.PHONY: all
all: $(PROGRAMS)

vlock: vlock.sh config.mk Makefile
	$(BOURNE_SHELL) -n $<
	sed \
		-e 's,%BOURNE_SHELL%,$(BOURNE_SHELL),' \
		-e 's,%PREFIX%,$(PREFIX),' \
		-e 's,%VLOCK_VERSION%,$(VLOCK_VERSION),' \
		$< > $@.tmp
	mv -f $@.tmp $@

ifneq ($(USE_ROOT_PASS),y)
vlock-current : override CFLAGS += -DNO_ROOT_PASS
endif

ifeq ($(AUTH_METHOD),pam)
vlock-current : override LDFLAGS += $(PAM_LIBS)
endif

ifeq ($(AUTH_METHOD),shadow)
vlock-current : override LDFLAGS += -lcrypt
endif

vlock-current: vlock-current.c prompt.c auth-$(AUTH_METHOD).c

ifeq ($(USE_PAM),y)
vlock-nosysrq vlock-all : override LDFLAGS += $(PAM_LIBS)
vlock-nosysrq vlock-all : override CFLAGS += -DUSE_PAM
endif

ifndef VLOCK_GROUP
VLOCK_GROUP = root
ifndef VLOCK_MODE
VLOCK_MODE = 4711
endif
else # VLOCK_GROUP is defined
ifndef VLOCK_MODE
VLOCK_MODE = 4710
endif
endif

.PHONY: install
install: install-programs install-man

.PHONY: install-programs
install-programs: $(PROGRAMS)
	$(INSTALL) -D -m 755 -o root -g $(ROOT_GROUP) vlock $(DESTDIR)$(PREFIX)/bin/vlock
	$(INSTALL) -D -m 4711 -o root -g $(ROOT_GROUP) vlock-current $(DESTDIR)$(PREFIX)/sbin/vlock-current
	$(INSTALL) -D -m 755 -o root -g $(ROOT_GROUP) vlock-all $(DESTDIR)$(PREFIX)/sbin/vlock-all
	$(INSTALL) -D -m $(VLOCK_MODE) -o root -g $(VLOCK_GROUP) vlock-nosysrq $(DESTDIR)$(PREFIX)/sbin/vlock-nosysrq
	$(INSTALL) -D -m $(VLOCK_MODE) -o root -g $(VLOCK_GROUP) vlock-new $(DESTDIR)$(PREFIX)/sbin/vlock-new

.PHONY: install-man
install-man:
	$(INSTALL) -D -m 644 -o root -g $(ROOT_GROUP) man/vlock.1 $(DESTDIR)$(PREFIX)/share/man/man1/vlock.1
	$(INSTALL) -D -m 644 -o root -g $(ROOT_GROUP) man/vlock-current.8 $(DESTDIR)$(PREFIX)/share/man/man8/vlock-current.8
	$(INSTALL) -D -m 644 -o root -g $(ROOT_GROUP) man/vlock-all.8 $(DESTDIR)$(PREFIX)/share/man/man8/vlock-all.8
	$(INSTALL) -D -m 644 -o root -g $(ROOT_GROUP) man/vlock-new.8 $(DESTDIR)$(PREFIX)/share/man/man8/vlock-new.8
	$(INSTALL) -D -m 644 -o root -g $(ROOT_GROUP) man/vlock-nosysrq.8 $(DESTDIR)$(PREFIX)/share/man/man8/vlock-nosysrq.8

.PHONY: clean
clean:
	rm -f $(PROGRAMS)

## vlock 2.2.2

=== Makefile ===
# vlock makefile

include config.mk

VPATH = src

VLOCK_VERSION = 2.2.2

PROGRAMS = vlock vlock-main

.PHONY: all
all: $(PROGRAMS)

.PHONY: debug
debug:
	@$(MAKE) DEBUG=y

ifeq ($(ENABLE_PLUGINS),yes)
all: plugins
endif

.PHONY: plugins
plugins: modules scripts

.PHONY: modules
modules:
	@$(MAKE) -C modules

.PHONY: scripts
scripts:
	@$(MAKE) -C scripts

.PHONY: check memcheck
check memcheck:
	@$(MAKE) -C tests $@

### configuration ###

config.mk:
	$(info )
	$(info ###################################################)
	$(info # Creating default configuration.                 #)
	$(info # Run ./configure or edit config.mk to customize. #)
	$(info ###################################################)
	$(info )
	@./configure --quiet

### installation rules ###

.PHONY: install
install: install-programs install-man

ifeq ($(ENABLE_PLUGINS),yes)
install: install-plugins
endif

.PHONY: install-programs
install-programs: $(PROGRAMS)
	$(MKDIR_P) -m 755 $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 755 -o root -g $(ROOT_GROUP) vlock $(DESTDIR)$(BINDIR)/vlock
	$(MKDIR_P) -m 755 $(DESTDIR)$(PREFIX)/sbin
	$(INSTALL) -m 4711 -o root -g $(ROOT_GROUP) vlock-main $(DESTDIR)$(SBINDIR)/vlock-main

.PHONY: install-plugins
install-plugins: install-modules install-scripts

.PHONY: install-modules
install-modules:
	@$(MAKE) -C modules install

.PHONY: install-scripts
install-scripts:
	@$(MAKE) -C scripts install

.PHONY: install-man
install-man:
	$(MKDIR_P) -m 755 $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -m 644 -o root -g $(ROOT_GROUP) man/vlock.1 $(DESTDIR)$(MANDIR)/man1/vlock.1
	$(MKDIR_P) -m 755 $(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -m 644 -o root -g $(ROOT_GROUP) man/vlock-main.8 $(DESTDIR)$(MANDIR)/man8/vlock-main.8
	$(MKDIR_P) -m 755 $(DESTDIR)$(MANDIR)/man5
	$(INSTALL) -m 644 -o root -g $(ROOT_GROUP) man/vlock-plugins.5 $(DESTDIR)$(MANDIR)/man5/vlock-plugins.5


### build rules ###

vlock: vlock.sh config.mk Makefile
	$(BOURNE_SHELL) -n $<
	sed \
		-e 's,%BOURNE_SHELL%,$(BOURNE_SHELL),' \
		-e 's,%PREFIX%,$(PREFIX),' \
		-e 's,%VLOCK_VERSION%,$(VLOCK_VERSION),' \
		-e 's,%VLOCK_ENABLE_PLUGINS%,$(ENABLE_PLUGINS),' \
		$< > $@.tmp
	mv -f $@.tmp $@

override CFLAGS += -Isrc

vlock-main: vlock-main.o prompt.o auth-$(AUTH_METHOD).o console_switch.o util.o

auth-pam.o: auth-pam.c prompt.h auth.h
auth-shadow.o: auth-shadow.c prompt.h auth.h
prompt.o: prompt.c prompt.h
vlock-main.o: vlock-main.c auth.h prompt.h util.h
plugins.o: plugins.c tsort.h plugin.h plugins.h list.h util.h
module.o : override CFLAGS += -DVLOCK_MODULE_DIR="\"$(MODULEDIR)\""
module.o: module.c plugin.h list.h util.h
script.o : override CFLAGS += -DVLOCK_SCRIPT_DIR="\"$(SCRIPTDIR)\""
script.o: script.c plugin.h process.h list.h util.h
plugin.o: plugin.c plugin.h list.h util.h
tsort.o: tsort.c tsort.h list.h
list.o: list.c list.h util.h
console_switch.o: console_switch.c console_switch.h
process.o: process.c process.h
util.o: util.c util.h

ifneq ($(ENABLE_ROOT_PASSWORD),yes)
vlock-main.o : override CFLAGS += -DNO_ROOT_PASS
endif

ifeq ($(AUTH_METHOD),pam)
vlock-main : override LDLIBS += $(PAM_LIBS)
endif

ifeq ($(AUTH_METHOD),shadow)
vlock-main : override LDLIBS += $(CRYPT_LIB)
endif

ifeq ($(ENABLE_PLUGINS),yes)
vlock-main: plugins.o plugin.o module.o process.o script.o tsort.o list.o
# -rdynamic is needed so that the all plugin can access the symbols from console_switch.o
vlock-main : override LDFLAGS += -rdynamic
vlock-main : override LDLIBS += $(DL_LIB)
vlock-main.o : override CFLAGS += -DUSE_PLUGINS
vlock-main.o: plugins.h
endif

.PHONY: realclean
realclean: clean
	$(RM) config.mk

.PHONY: clean
clean:
	$(RM) $(PROGRAMS) $(wildcard *.o)
	@$(MAKE) -C modules clean
	@$(MAKE) -C scripts clean
	@$(MAKE) -C tests clean

=== modules/Makefile ===
include ../config.mk

MODULES += $(EXTRA_MODULES)

.PHONY: all
all: $(MODULES)

.PHONY: install
install: $(addprefix install-, $(MODULES))

MODULE_GROUP = $(ROOT_GROUP)
MODULE_MODE = 0755

override CFLAGS += -I../src -fPIC

#special build rules

caca.so : override LDLIBS += -lcaca -lncurses

all.o: all.c ../src/console_switch.h

#generic build rule

%.so : override LDFLAGS += -shared
%.so: %.o
	$(LINK.o) -shared $^ $(LOADLIBES) $(LDLIBS) -o $@

# special installation rules

install-new.so : MODULE_GROUP=$(VLOCK_GROUP)
install-new.so : MODULE_MODE=$(VLOCK_MODULE_MODE)
install-nosysrq.so : MODULE_GROUP=$(VLOCK_GROUP)
install-nosysrq.so : MODULE_MODE=$(VLOCK_MODULE_MODE)

# generic installation rule

.PHONY: install-%.so
install-%.so: %.so
	$(MKDIR_P) -m 755 $(DESTDIR)$(MODULEDIR)
	$(INSTALL) -m $(MODULE_MODE) -o root -g $(MODULE_GROUP) $< $(DESTDIR)$(MODULEDIR)/$<

.PHONY: clean
clean:
	$(RM) $(wildcard *.o) $(wildcard *.so)

=== scripts/Makefile ===
include ../config.mk

.PHONY: all
all: $(SCRIPTS)

.PHONY: install
install: $(addprefix install-, $(SCRIPTS))

SCRIPT_GROUP = $(ROOT_GROUP)
SCRIPT_MODE = 0755

install-%.sh : SCRIPT_TARGET=$(<:.sh=)
install-%: %
	$(MKDIR_P) -m 755 $(DESTDIR)$(SCRIPTDIR)
	$(INSTALL) -m $(SCRIPT_MODE) -o root -g $(SCRIPT_GROUP) $< $(DESTDIR)$(SCRIPTDIR)/$(SCRIPT_TARGET)

.PHONY: clean
clean:

=== tests/Makefile ===
include ../config.mk

VPATH = ../src

override CFLAGS+=-I../src

export VLOCK_TEST_OUTPUT_MODE
VLOCK_TEST_OUTPUT_MODE = verbose

.PHONY: all
all: check

TESTED_SOURCES = list.c tsort.c util.c process.c
TESTED_OBJECTS = $(TESTED_SOURCES:.c=.o)

TEST_SOURCES = $(TESTED_SOURCES:%=test_%)
TEST_OBJECTS = $(TEST_SOURCES:.c=.o)

vlock-test : override LDFLAGS+=-lcunit
vlock-test: vlock-test.o $(TEST_OBJECTS) $(TESTED_OBJECTS)

vlock-test.o: $(TEST_SOURCES:.c=.h)

ifeq ($(COVERAGE),y)
vlock-test : override LDFLAGS+=--coverage
$(TESTED_OBJECTS) : override CFLAGS+=--coverage
endif

.PHONY: check
check: vlock-test
	@./vlock-test

.PHONY: memcheck
memcheck : VLOCK_TEST_OUTPUT_MODE=silent
memcheck: vlock-test
	@valgrind \
		--tool=memcheck \
		--suppressions=.valgrind-supressions \
		--error-exitcode=1 \
		--leak-check=full \
		--show-reachable=yes \
		--track-fds=yes \
		--child-silent-after-fork=yes \
		./vlock-test

.PHONY: clean
clean:
	$(RM) vlock-test $(wildcard *.o)
	$(RM) $(wildcard *.gcno) $(wildcard *.gcda) $(wildcard *.gcov)

=== debian/changelog ===
vlock (2.2.2-5) unstable; urgency=medium

  * QA upload.
  * Bump debhelper compiled to 7 to process debian/clean.
    + Convert dh_clean -k to dh_prep.
  * Remove dpkg-statoverride for absent module new.so.
  * Remove unneeded dpkg-statoverrides. (Closes: #698860)
    + Change permissions for usr/lib/vlock/modules/*.so and
      usr/sbin/vlock-main during build.
    + Permanently remove now unneded dpkg-statoverride for vlock-main and
      all.so
  * Remove dpkg-statoverrides for nosysrq.so during purge.
    (Closes: #520737)
  * Convert source format to 3.0 (quilt) to add a patch.
  * Do not use fd_set with potentially large indices. Thanks to Jakub Wilk and
    Julien Cristau. (Closes: #754594)

 -- Helmut Grohne <helmut@subdivi.de>  Tue, 15 Jul 2014 23:00:29 +0200

vlock (2.2.2-4) unstable; urgency=medium

  * QA upload.
  * Set maintainer to QA group. (Addresses: #753662)
  * Disable the new.so module, because it is unfixably broken. (Closes:
    #702705)
    + Mention in NEWS.
  * Add debian/source/format.
  * Remove unused lintian override shared-lib-without-dependency-information.
  * Declare compliance with policy version 3.9.5.
    + Add missing build-{arch,indep} targets for policy version 3.9.4.
  * Upgrade debhelper compatibility to 6 from deprecated level 4.
    + Use dh_lintian.
  * Clean config.mk to avoid it ending up in the diff.
  * Enable hardening.
  * Update copyright to refer to GPL-2 rather than GPL.
  * Add ${misc:Depends} to Depends to follow debhelper recommendation.
  * Mark Multi-Arch:foreign.
  * Update watch file to indicate that there is no upstream anymore.
  * Add read-permission to statoverrides. (Closes: #529552)

 -- Helmut Grohne <helmut@subdivi.de>  Fri, 04 Jul 2014 19:38:25 +0200

vlock (2.2.2-3) unstable; urgency=low

  * Don't try to chgrp to "vlock" during build time (Closes: #486665)
  * Bump standards version (No changes)

 -- Alexander Wirt <formorer@debian.org>  Tue, 17 Jun 2008 17:13:25 +0200

vlock (2.2.2-2) unstable; urgency=low

  * Fix typo in vlock.postinst (Closes: #486581) 

 -- Alexander Wirt <formorer@debian.org>  Tue, 17 Jun 2008 11:43:13 +0200

vlock (2.2.2-1) unstable; urgency=low

  * New upstream release
  * Depend on adduser (Closes: #480545)
  * Add watchfile (Closes: #456019)

 -- Alexander Wirt <formorer@debian.org>  Sun, 25 May 2008 15:15:41 +0200

vlock (2.1-2) unstable; urgency=low

  * Fix copyright file 
  * Change maintainer

 -- Alexander Wirt <formorer@debian.org>  Wed, 12 Sep 2007 07:21:51 +0200

vlock (2.1-1) unstable; urgency=low

  * New upstream release
    - Support for BSD (Closes: #435580)

 -- Alexander Wirt <formorer@debian.org>  Tue, 11 Sep 2007 07:59:40 +0200

vlock (2.0-4) unstable; urgency=low

  * Fix utf-8 trouble. (Closes: 439619) 

 -- Alexander Wirt <formorer@debian.org>  Sun, 26 Aug 2007 07:41:45 +0200

vlock (2.0-3) unstable; urgency=medium

  * Fix permissions of /usr/sbin/vlock-current

 -- Alexander Wirt <formorer@debian.org>  Sat, 25 Aug 2007 09:58:27 +0200

vlock (2.0-2) unstable; urgency=low

  * Check for overrides every time (Closes: #437822) 

 -- Alexander Wirt <formorer@debian.org>  Fri, 24 Aug 2007 09:44:22 +0200

vlock (2.0-1) unstable; urgency=low

  * New upstream release

 -- Alexander Wirt <formorer@debian.org>  Mon, 13 Aug 2007 19:37:22 +0200

vlock (2.0~rc2-1) experimental; urgency=low

  * New upstream release

 -- Alexander Wirt <formorer@debian.org>  Wed, 08 Aug 2007 13:09:55 +0200

vlock (2.0~rc1-1) unstable; urgency=low

  * New upstream release

 -- Alexander Wirt <formorer@debian.org>  Sun, 05 Aug 2007 16:50:34 +0200

vlock (1.3-10) unstable; urgency=low

  * Add a patch from Guido Guenther that adds better checking for the return
    code of correct_password() (Closes: #364081)
  * Add a patch Daniel Kahn Gillmor thats stats the PAM Session only after
    pressing enter. That prevents some problems with some exclusive-access PAM
    modules like opensc (Closes: #318507)
  * Include common-auth in the pam file (Closes: #265297)
  * Depend on libpam-modules (Closes: #55834) 
  * Bump standards version

 -- Alexander Wirt <formorer@debian.org>  Wed, 19 Jul 2006 20:26:23 +0200

vlock (1.3-9) unstable; urgency=low

  * New Maintainer/Uploaders (closes: #321755).
  * Use debhelper compatibility level 4 instead of level 2.  Accordingly
    adapted the build time dependencies.
  * debian/rules cleanup:
    - removing commented out dh_make cruft,
    - use "rm -f .." instead of "-rm ..",
    - change to "new" chown syntax of chown user:group, replacing user.group.
    - comment out DH_VERBOSE=1
  * Remove debian/conffiles.  It only contained etc/pam.d/vlock, which
    is marked as conffile by debhelper automatically.
  * Increased standards version from 3.5.7.0 to 3.6.2 (no changes necessary).
  * Rename debian/docs to debian/vlock.docs to be consistent with
    debian/vlock.dirs.
  * Fix debian/changelog: Parts have been duplicated in a previous version,
    clean up the mess.
  * Add myself to debian/copyright.
  * Update the address of the Free Software Foundation in debian/copyright.
  * Add lintian override for vlock being suid root.
  * Use dh_install instead of install to copy the vlock binary in place.
    This way we support DEB_BUILD_OPTIONS=nostrip.
  * Remove vlock.man in clean target as it's build by upstream's Makefile
    anyway and we don't need it in the diff.
  * Do not build vlock.man during build.

 -- Peter Palfrader <weasel@debian.org>  Mon, 20 Feb 2006 12:42:06 +0100

vlock (1.3-8) unstable; urgency=medium

  * Argh, forgot about this bug when RL jumped at me.
    Applied patch from RISKO Gergely.
    (closes: #181931)

 -- Zephaniah E. Hull <warp@debian.org>  Sun, 30 Mar 2003 15:32:58 -0500

vlock (1.3-7) unstable; urgency=low

  * Whoops, make sgid again. (So we can ask root's password!)
  * Better error handling for PAM. (closes: #53049)
  * Kill some unused template files in debian/
  * Update standards-version.


=== debian/control ===
Source: vlock
Section: utils
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 7), libpam0g-dev
Standards-Version: 3.9.5

Package: vlock
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpam-modules, adduser
Conflicts: suidmanager (<< 0.50)
Multi-Arch: foreign
Description: Virtual Console locking program
 vlock either locks the current terminal (which may be any kind of
 terminal, local or remote), or locks the entire virtual console
 system, completely disabling all console access.  vlock gives up
 these locks when either the password of the user who started vlock
 or the root password is typed.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS := $(shell dpkg-buildflags --get CPPFLAGS; dpkg-buildflags --get CFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

build-indep:
build-arch: build-stamp
build: build-arch build-indep
build-stamp: config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) PREFIX=/usr
	touch build-stamp

config.status: configure
	dh_testdir
	./configure VLOCK_GROUP=root EXTRA_CFLAGS="$(CFLAGS)" EXTRA_LDFLAGS="$(LDFLAGS)"
	sed -i 's/new\.so//' config.mk # disable unfixably insecure module #702705
clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp install-stamp

	[ ! -f Makefile ] || $(MAKE) clean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/vlock/ PREFIX=/usr 

	dh_lintian
	touch install-stamp

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs README SECURITY PLUGINS
	dh_installexamples --exclude=Makefile
	dh_installmenu
	dh_installpam
	dh_installcron
	dh_installman
	dh_installinfo
	dh_installchangelogs ChangeLog
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	chmod 0755 debian/vlock/usr/lib/vlock/modules/*.so
	chmod 4755 debian/vlock/usr/sbin/vlock-main
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install build-arch build-indep

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

# There is no upstream anymore.
# Former versions were found at:
# http://cthulhu.c3d2.de/~toidinamai/vlock/archive/vlock-([\d\.]*)\.tar.gz
